//+------------------------------------------------------------------+
//|                                                  CCI Woodie like |
//|                                                CCI woodie wy.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  LimeGreen
#property indicator_color4  Tomato
#property indicator_color5  LimeGreen
#property indicator_color6  Tomato
#property indicator_color7  DimGray
#property indicator_color8  YellowGreen
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  2

//
//
//
//
//

extern int   CCIPeriod      = 14;
extern int   TrendPeriod    =  6;
extern int   TurboCCIPeriod =  0;
extern int   LSMAPeriod     = 25;
extern int   LSMAPrice      = PRICE_CLOSE;
extern int   EMAPeriod      = 34;
extern int   EMAPrice       = PRICE_CLOSE;
extern bool  ShowLsmaEma    = true;
extern bool  ShowZones      = true;
extern int   YellowBarBack  = 500;
extern int   YellowBarWidth = 2;
extern color YellowBarColor = Yellow;
extern color ZonesColor     = C'30,33,36';
extern color LinesColor     = C'50,53,56';

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];
string ShortName;
int    Window;
int    NameLen;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,buffer5);
   SetIndexBuffer(5,buffer6);
   SetIndexBuffer(6,buffer7);
   SetIndexBuffer(7,buffer8);
         SetIndexLabel(0,"Trend up");
         SetIndexLabel(1,"Trend down");
         SetIndexLabel(2,"Close above LSMA");
         SetIndexLabel(3,"Close bellow LSMA");
         SetIndexLabel(4,"Close above EMA");
         SetIndexLabel(5,"Close bellow EMA");
         SetIndexLabel(6,"CCI");
         SetIndexLabel(7,"Turbo CCI");

   if (YellowBarBack==0) YellowBarBack=Bars;

   //
   //
   //
   //
   //

   TrendPeriod = MathMax(3,TrendPeriod);   
   ShortName   = MakeUniqueName("CCI Woodie "," ("+CCIPeriod+","+TurboCCIPeriod+")");
   NameLen     = StringLen(ShortName);
   IndicatorShortName(ShortName);
   return(0);
}
int deinit()
{
   DeleteBounds();
   for (int i = ObjectsTotal(); i>=0; i--)
   {
         string name = ObjectName(i);
         if (StringSubstr(name,0,NameLen) == ShortName) ObjectDelete(name);
   }         
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   int    i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           Window=WindowFind(ShortName);           

   //
   //
   //
   //
   //
   
   for (i=limit;i>=0;i--)
   {
      if (TurboCCIPeriod>1) buffer8[i] = iCCI(NULL,0,TurboCCIPeriod,PRICE_TYPICAL,i); 
                            buffer7[i] = iCCI(NULL,0,CCIPeriod     ,PRICE_TYPICAL,i);
            SetHisto(i);
            if (ShowLsmaEma) SetLsmaEma(i);
   }
   
   //
   //
   //
   //
   //
   
   if (ShowZones) UpdateBounds();
   return(0);
}
  
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void SetHisto(int i)
{
   int k,s;

   buffer1[i] = EMPTY_VALUE;
   buffer2[i] = EMPTY_VALUE;
   
   //
   //
   //
   //
   //

      if (buffer7[i]>0)
         if (buffer1[i+1] != EMPTY_VALUE) s = TrendPeriod;
         else
            for (k=1,s= 1; k<TrendPeriod; k++,s++) if (buffer2[i+k] != EMPTY_VALUE) break;

      if (buffer7[i]<0)
         if (buffer2[i+1] != EMPTY_VALUE) s = -TrendPeriod;
         else
            for (k=1,s=-1; k<TrendPeriod; k++,s--) if (buffer1[i+k] != EMPTY_VALUE) break;

      if (s ==  TrendPeriod) buffer1[i] = buffer7[i];
      if (s == -TrendPeriod) buffer2[i] = buffer7[i];
   
   //
   //
   //
   //
   //
   
   string YellowName = ShortName+TimeToStr(Time[i]); ObjectDelete(YellowName);
   
   if ((YellowBarWidth > 0) && (i < YellowBarBack) && (MathAbs(s) == (TrendPeriod-1)))
                     drawYellowBar(YellowName,i);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void SetLsmaEma(int i)
{
   double lsmaValue = iLsma(i);
   double emaValue  = iMA(NULL,0,EMAPeriod,0,MODE_EMA,EMAPrice,i);
   
   buffer3[i] = EMPTY_VALUE;
   buffer4[i] = EMPTY_VALUE;
   buffer5[i] = EMPTY_VALUE;
   buffer6[i] = EMPTY_VALUE;
      if (Close[i] > lsmaValue) buffer3[i] =  5.00;
      if (Close[i] < lsmaValue) buffer4[i] =  5.00;
      if (Close[i] > emaValue)  buffer5[i] = -5.00;
      if (Close[i] < emaValue)  buffer6[i] = -5.00;
}

//
//
//
//
//

double iLsma(int shift)
{
   double lengthvar = (LSMAPeriod + 1.0)/3.0;
   double sum       = 0.0;
   double res       = 0.0;

   for(int i = LSMAPeriod; i > 0; i--)
      sum += (i-lengthvar)*iMA(NULL,0,1,0,MODE_SMA,LSMAPrice,shift+LSMAPeriod-i);
      res  = sum*6.0/(LSMAPeriod*(LSMAPeriod+1.0));
   return(res);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}

//
//
//
//
//

void DeleteBounds()
{
   ObjectDelete(ShortName+"-1"); ObjectDelete(ShortName+"-11"); ObjectDelete(ShortName+"-12");
   ObjectDelete(ShortName+"-2"); ObjectDelete(ShortName+"-21"); ObjectDelete(ShortName+"-22");
   ObjectDelete(ShortName+"-3"); ObjectDelete(ShortName+"-31"); ObjectDelete(ShortName+"-32");
}
void UpdateBounds()
{
   SetUpBound(ShortName+"-1", 300, 200);
   SetUpBound(ShortName+"-2", 100,-100);
   SetUpBound(ShortName+"-3",-200,-300);
}

//
//
//
//
//

void SetUpBound(string name, double up, double down)
{
   if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,OBJ_RECTANGLE,Window,0,0);
            ObjectSet(name,OBJPROP_PRICE1,up);
            ObjectSet(name,OBJPROP_PRICE2,down);
            ObjectSet(name,OBJPROP_COLOR,ZonesColor);
            ObjectSet(name,OBJPROP_BACK,true);
            ObjectSet(name,OBJPROP_TIME1,iTime(NULL,0,Bars-1));
      }
   if (ObjectGet(name,OBJPROP_TIME2) != iTime(NULL,0,0))
       ObjectSet(name,OBJPROP_TIME2,    iTime(NULL,0,0));
      
   //
   //
   //
   //
   //
          
   if (ObjectFind(name+"1") == -1) drawLine(name+"1",up);
   if (ObjectGet(name+"1",OBJPROP_TIME2) != iTime(NULL,0,0))
       ObjectSet(name+"1",OBJPROP_TIME2,    iTime(NULL,0,0));
   if (ObjectFind(name+"2") == -1) drawLine(name+"2",down);
   if (ObjectGet(name+"2",OBJPROP_TIME2) != iTime(NULL,0,0))
       ObjectSet(name+"2",OBJPROP_TIME2,    iTime(NULL,0,0));
}

//
//
//
//
//

void drawLine(string name, double current)
{
   ObjectCreate(name,OBJ_TREND,Window,iTime(NULL,0,Bars-1),current,Time[0],current);
      ObjectSet(name,OBJPROP_COLOR,LinesColor);
      ObjectSet(name,OBJPROP_RAY,false);
      ObjectSet(name,OBJPROP_BACK,true);
}

//
//
//
//
//

void drawYellowBar(string name, int i)
{
   if (ObjectFind(name) == -1)
      ObjectCreate(name,OBJ_TREND,Window,Time[i],0,Time[i],buffer7[i]);
         ObjectSet(name,OBJPROP_COLOR,YellowBarColor);
         ObjectSet(name,OBJPROP_WIDTH,YellowBarWidth);
         ObjectSet(name,OBJPROP_RAY,false);
         ObjectSet(name,OBJPROP_BACK,true);
         ObjectSet(name,OBJPROP_PRICE2,buffer7[i]);
}